//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

#include "OmaLCD.h"
#include "MBMarvot.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TDLPortIO"
#pragma resource "*.dfm"

#define G_BASE 0x0200   // grafiikkamuistin base address
#define T_BASE 0x0000   // tekstimuistin base address
#define BYTES_PER_ROW 40 // merkki rivill

#define BASE 0x378      // lpt portin osoite


TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Lopeta_Button1Click(TObject *Sender)
{
Close();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StartLPTDriver_Button1Click(TObject *Sender)
{
StartLPTDriver();
StartLPTDriver_Edit1->Text="OK";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PutByte_Button1Click(TObject *Sender)
{
WriteData(110);
WriteCtrl(0xC0);
}

void __fastcall TForm1::InitLCD_Button1Click(TObject *Sender)
{
InitLCD();
InitLCD_Edit1->Text="OK";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetXY_ButtonClick(TObject *Sender)
{
SetLCDXY(SetXY_Edit2->Text.ToInt(),SetXY_Edit1->Text.ToInt());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetLCDCursor_ButtonClick(TObject *Sender)
{
SetLCDCursor(SetLCDCursor_Edit2->Text.ToInt(),SetLCDCursor_Edit1->Text.ToInt());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClearLCDText_Button1Click(TObject *Sender)
{
ClearLCDText();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClearLCDGraph_Button1Click(TObject *Sender)
{
ClearLCDGraph();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PrintLCDText_Button1Click(TObject *Sender)
{
PrintLCDText(PrintLCDText_Edit1->Text.c_str());
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetLCDPixel_Button1Click(TObject *Sender)
{
SetLCDPixel(30,30);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CharGenROM_Button1Click(TObject *Sender)
{
int i, c;
unsigned int cc;

ClearLCDText();
WriteCtrl(0x97);
for (c=0;c<10;c++) {
  SetLCDXY(0,0);
  for (i=0;i<320;i++){
    cc = (unsigned int) (c+i)%0x7F;
    WriteData(cc);
    WriteCtrl(0xc0);
  }

}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MBM_Button1Click(TObject *Sender)
{
Form2->ShowModal();
}
//---------------------------------------------------------------------------




/* OMAT LCD FUNKTIOT *******************************************/
/***************************************************************/

void __fastcall TForm1::StartLPTDriver(void)
{
        //ajurin hakemisto
        DLPortIO1->DriverPath=ExtractFileDir(ParamStr(0));
        // ajurin avaus
        DLPortIO1->OpenDriver();
        if (!DLPortIO1->ActiveHW)
   {
      MessageDlg("Could not open the DriverLINX driver.",
                 mtError, TMsgDlgButtons() << mbOK, 0);
   }
}

void __fastcall TForm1::WaitDisplayReady(void)
// lukee nytn status byten ja varmistaa,
// ett nytt on valmiina ennen kirjoitusta

// ei sisll viel mitn tarkistusta sen varalta,
// ett status byten luku ei onnistu, joten
// ohjelma on melko helppo saada jumiin

{
  int Tmp;

       Tmp = DLPortIO1->Port[BASE + 0x402];
       Tmp = Tmp & 0x1F;
       Tmp = Tmp | 0x20;
       DLPortIO1->Port[BASE + 0x402] = Tmp;

       do{

             DLPortIO1->Port[BASE + 2] = 0x20 + 4 + 2;     //In, CD=1, CS=0, Wr=1
             DLPortIO1->Port[BASE + 2] = 0x20 + 4 + 2 + 8; //In, CD=1, CS=0, Wr=1, Rd=0
             Tmp = DLPortIO1->Port[BASE];
             DLPortIO1->Port[BASE + 2] = 0x20 + 4 + 2;     //In, CD=1, CS=0, Wr=1

       }while ((Tmp & 3) != 3 );
       DLPortIO1->Port[BASE + 2] = 0;
}

void __fastcall TForm1::WriteData(BYTE Data)
{
  WriteData_Edit1->Text=WriteData_Edit1->Text+Data+" ";
  WaitDisplayReady();
  DLPortIO1->Port[BASE] = Data;
  DLPortIO1->Port[BASE + 2] = 0; // C/D = L (Data)
  DLPortIO1->Port[BASE + 2] = 2; // CE
  DLPortIO1->Port[BASE + 2] = 3; // CE+WR
  DLPortIO1->Port[BASE + 2] = 2; // CE
  DLPortIO1->Port[BASE + 2] = 0;

}

void __fastcall TForm1::WriteCtrl(BYTE Command)
{
  WriteCtrl_Edit1->Text=WriteCtrl_Edit1->Text+Command+" ";
  WaitDisplayReady();
  DLPortIO1->Port[BASE] = Command;
  DLPortIO1->Port[BASE + 2] = 4;   // C/D = H (ctrl)
  DLPortIO1->Port[BASE + 2] = 4+2; // CE
  DLPortIO1->Port[BASE + 2] = 4+3; // CE+WR
  DLPortIO1->Port[BASE + 2] = 4+2; // CE
  DLPortIO1->Port[BASE + 2] = 0;
}

void __fastcall TForm1::InitLCD(void)
{
  // Display init
  WriteData(T_BASE & 0xFF);   //Data1: LowAddress
  WriteData(T_BASE >> 8);     //Data2: HighAddress
  WriteCtrl(0x40);            //Command: 0x40 -> 01000000

  WriteData(BYTES_PER_ROW);  //Data1: Colums
  WriteData(0);              //Data2: 0
  WriteCtrl(0x41);           //Command: 0x41 -> 01000001

  WriteData(G_BASE & 0xFF);  //Data1: LowAddress
  WriteData(G_BASE >> 8);    //Data2: HighAddress
  WriteCtrl(0x42);           //Command: 0x42 -> 01000010

  WriteData(BYTES_PER_ROW);  //Data1: Colums
  WriteData(0);              //Data2: 0
  WriteCtrl(0x43);           //Command: 0x43 -> 01000011

  //Internal CGROM Mode, OR Mode
  WriteCtrl(0x80); // OR Mode    //80->10000000

  WriteCtrl(0xa7); // cursor is 8 lines high
  WriteData(0x00);
  WriteData(0x00);
  WriteCtrl(0x21); // put cursor at (x,y)

  //DisplayMode
  WriteCtrl(0x97);

  // CG RAM
  // WriteData(2);
  // WriteData(0);
  // WriteCtrl(0x22);

}

void __fastcall TForm1::SetLCDXY(int x, int y)
{
int addr;
  addr = T_BASE + (y * BYTES_PER_ROW) + x;
  WriteData(addr & 0xFF);
  WriteData(addr >> 8);
  WriteCtrl(0x24);
}

void __fastcall TForm1::SetLCDCursor(int x, int y)
{
  WriteData(x);
  WriteData(y);
  WriteCtrl(0x21);
}

void __fastcall TForm1::ClearLCDText(void)
{
  int i;

  WriteData(T_BASE & 0xFF);
  WriteData(T_BASE >> 8);
  WriteCtrl(0x24);      // address pointer T_BASE alkuun

  for (i=0;i<320;i++) {
        WriteData(0); WriteCtrl(0xc0); // kirjoita data ja inc ptr
  }
}

void __fastcall TForm1::ClearLCDGraph(void)
{
  int i;

  WriteData(G_BASE & 0xFF);
  WriteData(G_BASE >> 8);
  WriteCtrl(0x24); // address pointer G_BASE alkuun

  for (i=0;i<2560;i++){
        WriteData(0); WriteCtrl(0xc0); // kirjoita data ja inc ptr
  }
}

void __fastcall TForm1::PrintLCDText(char *string)
{
  unsigned int i;
  int c;

  for (i=0;i<strlen(string);i++){
        c = string[i] - 0x20; // muunnos ASCIIsta LCD:n merkkeihin
        if (c<0) c=0;
        WriteData(c);
        WriteCtrl(0xc0);
  }
}

void __fastcall TForm1::SetLCDPixel(int x, int y)   // ei toimi
{
  int addr;

  addr = G_BASE + (y*BYTES_PER_ROW) + (x/6);
  WriteData(addr & 0xFF);
  WriteData(addr >> 8);
  WriteCtrl(0x24);
  WriteCtrl(0xf8 | (5-(x % 6)));   // ???
}


